!! Copyright INRIA. Contributors : Julien DIAZ, Abdelaaziz EZZIANI 
!! and Nicolas LEGOFF 
!! 
!! Julien.Diaz@inria.fr, Abdelaaziz.Ezziani@univ-pau.fr 
!! and Nicolas.Le_goff@inria.fr
!! 
!! This software is a computer program whose purpose is to
!! compute the analytical solution of problems of waves propagation in two 
!! layered media such as
!! - acoustic/acoustic
!! - acoustic/elastodynamic
!! - acoustic/porous
!! - porous/porous,
!! based on the Cagniard-de Hoop method.
!! 
!! This software is governed by the CeCILL license under French law and
!! abiding by the rules of distribution of free software.  You can  use, 
!! modify and/ or redistribute the software under the terms of the CeCILL
!! license as circulated by CEA, CNRS and INRIA at the following URL
!! "http://www.cecill.info". 
!! 
!! As a counterpart to the access to the source code and  rights to copy,
!! modify and redistribute granted by the license, users are provided only
!! with a limited warranty  and the software's author,  the holder of the
!! economic rights,  and the successive licensors  have only  limited
!! liability. 
!! 
!! In this respect, the user's attention is drawn to the risks associated
!! with loading,  using,  modifying and/or developing or reproducing the
!! software by the user in light of its specific status of free software,
!! that may mean  that it is complicated to manipulate,  and  that  also
!! therefore means  that it is reserved for developers  and  experienced
!! professionals having in-depth computer knowledge. Users are therefore
!! encouraged to load and test the software's suitability as regards their
!! requirements in conditions enabling the security of their systems and/or 
!! data to be ensured and,  more generally, to use and operate it in the 
!! same conditions as regards security. 
!! 
!! The fact that you are presently reading this means that you have had
!! knowledge of the CeCILL license and that you accept its terms.
!! ========================================================================

function source(t)
  Use m_source
  Use m_const
  implicit none
  real*8,intent(in) :: t
  real*8 :: alpha,t1,t0,source
  t0=tdelay
  alpha=-pi**2*f0**2;
  if ((t.gt.0).and.(t.lt.2*t0)) then
     t1=t-t0
! Rickert:
!     source=2.*amp*alpha*(1+2*alpha*t1**2)*dexp(alpha*t1**2);
     source=2.*amp*alpha*(4*alpha*t1+(1+2*alpha*t1**2)*2*alpha*t1)*dexp(alpha*t1**2);
!Fourth derivative of gaussian:
!     source=-2*amp*alpha*(3+12*alpha*t1**2+4*alpha**2*t1**4)*exp(alpha*t1**2)
  else  
     source=0.D0
  end if
end function source
